use anyhow::Error;

use super::Repository;
use crate::database::Queryer;
use crate::domain::benutzer::model;

impl Repository {
    pub async fn alle_benutzer<'c, C: Queryer<'c>>(
        &self,
        db: C,
    ) -> Result<Vec<model::Benutzer>, Error> {
        const QUERY: &str = r#"
            SELECT *
            FROM benutzer
        "#;

        let benutzer = sqlx::query_as::<_, model::Benutzer>(QUERY)
            .fetch_all(db)
            .await?;

        Ok(benutzer)
    }
}
