use async_graphql::FieldResult;
use ulid::Ulid;

use crate::domain::benutzer::{
    entity,
    model::{Benutzer, BenutzerCreateInput},
};

use super::Service;

impl Service {
    pub async fn create_benutzer(&self, input: BenutzerCreateInput) -> FieldResult<Benutzer> {
        let benutzer_entity = entity::Benutzer {
            id: Ulid::new().into(),
            kennung: input.kennung,
            nachname: input.nachname,
            vorname: input.vorname,
        };

        Ok(self
            .repo
            .create_benutzer(&self.db, &benutzer_entity)
            .await?)
    }
}
