use async_graphql::dataloader::*;
use async_graphql::*;
use std::collections::HashMap;
use std::sync::Arc;

use crate::domain::gruppe::model::Gruppe;
use crate::domain::gruppe::service::Service;
use crate::scalar::Id;

pub struct GruppenLoader {
    pub pool: sqlx::PgPool,
}

impl Loader<Id> for GruppenLoader {
    type Value = Vec<Gruppe>;
    type Error = Arc<sqlx::Error>;

    async fn load(&self, keys: &[Id]) -> Result<HashMap<Id, Self::Value>, Self::Error> {
        let rows = Service::new(self.pool.clone())
            .gruppe_dataloader(keys)
            .await?;
        Ok(rows)
    }
}
