use anyhow::Error;

use super::Repository;
use crate::{database::Queryer, domain::gruppe::model};

impl Repository {
    pub async fn gruppe_alle<'c, C: Queryer<'c>>(
        &self,
        db: C,
    ) -> Result<Vec<model::Gruppe>, Error> {
        const QUERY: &str = r#"
            SELECT * FROM gruppen
        "#;

        let gruppen = sqlx::query_as::<_, model::Gruppe>(QUERY)
            .fetch_all(db)
            .await?;

        Ok(gruppen)
    }
}
