use std::{collections::HashMap, sync::Arc};

use crate::{domain::gruppe::model::Gruppe, scalar::Id};

use super::Service;

impl Service {
    pub async fn gruppe_dataloader(
        &self,
        keys: &[Id],
    ) -> Result<HashMap<Id, Vec<Gruppe>>, Arc<sqlx::Error>> {
        let grupen_dataloader = self.repo.gruppe_dataloader(&self.db, keys).await?;
        Ok(grupen_dataloader)
    }
}
