use anyhow::Error;
use chrono::Utc;
use ulid::Ulid;

use super::Service;
use crate::domain::gruppe::{
    entity,
    model::{self, GruppeUpdateInput},
};

impl Service {
    pub async fn gruppe_update(&self, input: GruppeUpdateInput) -> Result<model::Gruppe, Error> {
        let gruppe_input = entity::Gruppe {
            id: Ulid::new().into(),
            gruppenname: input.gruppenname,
            erstellt_am: None,
            geaendert_am: Some(Utc::now()),
        };

        let gruppe = self.repo.gruppe_erstellen(&self.db, &gruppe_input).await?;
        Ok(gruppe)
    }
}
