use crate::domain::benutzer::{model::Benutzer, model::BenutzerCreateInput, service::Service};
use async_graphql::{Context, FieldResult};
use sqlx::postgres::PgPool;

#[derive(Default)]
pub struct BenutzerMutation;

#[async_graphql::Object]
impl BenutzerMutation {
    async fn create_benutzer(
        &self,
        ctx: &Context<'_>,
        input: BenutzerCreateInput,
    ) -> FieldResult<Benutzer> {
        let pool = ctx.data::<PgPool>()?;

        let row = Service::new(pool.clone()).create_benutzer(input).await?;

        Ok(row)
    }

    // async fn update_hersteller(
    //     &self,
    //     ctx: &Context<'_>,
    //     input: HerstellerUpdateInput,
    // ) -> FieldResult<Hersteller> {
    //     let pool = ctx.data::<PgPool>()?;
    //     let row = Hersteller::update(pool, &input).await?;
    //     Ok(row)
    // }

    // async fn delete_hersteller(&self, ctx: &Context<'_>, id: Id) -> FieldResult<bool> {
    //     let pool = ctx.data::<PgPool>()?;
    //     Ok(Hersteller::delete(pool, &id).await?)
    // }
}
