use crate::domain::gruppe::{
    model::{Gruppe, GruppeErstelleInput},
    service::Service,
};
use async_graphql::{Context, FieldResult};
use sqlx::postgres::PgPool;

#[derive(Default)]
pub struct GruppeMutation;

#[async_graphql::Object]
impl GruppeMutation {
    async fn gruppe_ersellen(
        &self,
        ctx: &Context<'_>,
        input: GruppeErstelleInput,
    ) -> FieldResult<Gruppe> {
        let pool = ctx.data::<PgPool>()?;

        let gruppe = Service::new(pool.clone()).gruppe_erstellen(input).await?;
        Ok(gruppe)
    }
}
